package bean;
 
import java.sql.*;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Hashtable;

public class DataBean {

	private Connection con;
	
	public DataBean() {}
	
	public void setConnection(Connection con) throws Exception {
		this.con = con;
	}

	public void close() throws SQLException {
		con.close();
	}
	
        public int maxCol(String table, String field) throws SQLException {
		Statement stmt = con.createStatement();
		String query = "SELECT MAX (" + field + ") FROM " + table;
		ResultSet rs = stmt.executeQuery(query);
		int max = -1;
		if(rs.next()) {
			max = rs.getInt(field);
		}
		return max;
	}
		
	public boolean exists(String table, Hashtable thash) throws SQLException {
		Statement stmt = con.createStatement();
		String query = "SELECT * FROM " + table + " WHERE ";
		for(Enumeration keys = thash.keys(); keys.hasMoreElements();) {
			String key = (String) keys.nextElement();
			String values = (String)thash.get(key);
			query = query + key + " = '" + values + "' AND ";
		}

		query = query.substring(0, query.length() - 5);
		ResultSet rs = stmt.executeQuery(query);
		boolean res = rs.next();
		return res;
	}
	
	public void setUser(UserBean user) throws SQLException {
		Statement stmt = con.createStatement();
		stmt.executeUpdate("INSERT INTO USER VALUES ('" + user.getLogin() + "', '" + user.getPass() + "','" + user.getName() + "','" + user.getBornDate() + "','" + user.getIdNum() + "','" + user.getCountry() + "','" + user.getEmail() + "')");
	}
	
	
	public void getUser(Hashtable thash, UserBean user) throws SQLException {
		Statement stmt = con.createStatement();
		String query = "SELECT * FROM USER WHERE ";
		for(Enumeration keys = thash.keys(); keys.hasMoreElements();) {
			String key = (String)keys.nextElement();
			String value = (String)thash.get(key);
			query = query + key + " = '" + value + "' AND ";
		}

		query = query.substring(0, query.length() - 5);
		for(ResultSet rs = stmt.executeQuery(query); rs.next(); user.setLogin(rs.getString("login")))
		{
		    user.setPass(rs.getString("pass"));
			user.setName(rs.getString("name"));
			user.setBornDate(rs.getString("born_date"));
			user.setIdNum(rs.getString("id_num"));
			user.setCountry(rs.getString("country"));
			user.setEmail(rs.getString("email"));
		}

	}


	public void deleteUser(String login) throws SQLException {
			Statement stmt = con.createStatement();
			stmt.executeUpdate("DELETE FROM USER WHERE login LIKE '" + login+"'");
	}



	public void setEvent(EventBean event) throws SQLException {
		Statement stmt = con.createStatement();		
		stmt.executeUpdate("INSERT INTO EVENT VALUES (" + event.getCode() + ", '" + event.getOwner() + "'," + event.getDay() + "," + event.getMonth() + "," + event.getYear() + ",'" + event.getUrl() + "','" + event.getAction() + "')");
	}
	
	public Vector getAllEvents(String user, int month, int year) throws SQLException {
	    Vector v = new Vector();			
	    Statement stmt = con.createStatement();
	    String query = "SELECT * FROM EVENT WHERE owner = '"+user+"' AND month = "+month+" AND year ="+year;			
	    ResultSet rs = stmt.executeQuery(query);
	    while (rs.next()) {
	      EventBean event = new EventBean();
	      event.setOwner(rs.getString("owner"));
	      event.setUrl(rs.getString("url"));
	      event.setAction(rs.getString("action"));
	      event.setDay(rs.getInt("day"));
	      event.setMonth(rs.getInt("month"));
	      event.setYear(rs.getInt("year"));
	      v.add(event);				
    	    }
	    return v;					
	}	
	   
}